<?php

declare(strict_types=1);

namespace Drupal\countup\Plugin\CKEditor5Plugin;

use Drupal\ckeditor5\HTMLRestrictions;
use Drupal\ckeditor5\Plugin\CKEditor5PluginDefault;
use Drupal\Core\Extension\ModuleExtensionList;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\editor\EditorInterface;
use Drupal\editor\Entity\Editor;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Defines the "countup" plugin.
 *
 * @CKEditor5Plugin(
 *   id = "countup",
 *   label = @Translation("CountUp"),
 *   module = "countup"
 * )
 */
Class CountUp extends CKEditor5PluginDefault implements ContainerFactoryPluginInterface {

  /**
   * {@inheritdoc}
   *
   * @param \Drupal\Core\Extension\ModuleExtensionList $extensionListModule
   *   The module extension list.
   */
  public function __construct(array $configuration, string $plugin_id, $plugin_definition, protected ModuleExtensionList $extensionListModule) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition): static {
    return new static(
      $configuration,
      $plugin_id,
      $plugin_definition,
      $container->get('extension.list.module')
    );
  }

//  /**
//   * {@inheritdoc}
//   */
//  public function getElementsSubset(): array {
//    $plugin_definition = $this->getPluginDefinition();
//    $all_elements = $plugin_definition->getElements();
//    $subset = HTMLRestrictions::fromString(implode($all_elements));
//    $subset = $subset->intersect(HTMLRestrictions::fromString('<$text-container class="countup">'));
//    return $subset->toCKEditor5ElementsArray();
//  }

//  /**
//   * {@inheritdoc}
//   */
//  public function getButtons(): array {
//    return [
//      'countup' => [
//        'label' => $this->t('CountUp'),
//        'image' => $this->extensionListModule->getPath('countup') . '/js/plugins/countup/icons/icon.png',
//      ],
//    ];
//  }

//  /**
//   * {@inheritdoc}
//   */
//  public function getConfig(Editor $editor): array {
//    return [
//      'CountUp_dialogTitleAdd' => $this->t('Insert a count animation'),
//      'CountUp_dialogTitleEdit' => $this->t('Edit the count animation'),
//    ];
//  }

}
